(* This file contains examples of non trivial statements solved by Omega *)

Require Arith.
Require ZArith.
Require Omega.

(*
Set Omega Time.
Set Omega System.
Set Omega Action.
*)


Theorem test1:
(z,y,m,N:Z)
  (Zle ZERO z) -> (Zle ZERO y) -> (Zle ZERO m) -> 
   (Zle ZERO N) -> 
   ((Zle z y)/\(Zge z N)/\ ( y=m)/\~(Zlt y m)) ->
   (Zle (Zmult |2| z) y) ->
     (Zle (Zmult |2| z) y)
      /\(Zge (Zmult |2| z) N)/\ (y =m)\/(Zlt y m).

Intros; Omega.
Save.

Theorem test2:
 (x,y,t:Z) ~(((Zplus (Zmult |3| x) (Zplus (Zmult |2| y) |5|)) = |0|) /\ 
   (Zge t |3|) /\
   (Zle (Zplus (Zmult |3| x) (Zplus (Zmult |2| y) (Zplus t  |6|))) 
        |2|)).

Intros; Omega.
Save.

Theorem test3: (x,y:Z) ~((Zlt ZERO x) /\ (Zlt ZERO y) /\ 
	       (Zle y x) /\ (Zge (Zminus x y) x)).

Intros; Omega.
Save.

(* Transitivite du lt lexicographique sur les paires *)
Theorem test4:
(y,y0,y1,y2,y3,y4:Z)
  ((Zlt y y1)\/(y=y1/\(Zlt y0 y2))) ->
  ((Zlt y1 y3)\/(y1=y3/\(Zlt y2 y4))) ->
   ((Zlt y y3)\/(y=y3/\(Zlt y0 y4))).

Intros; Omega.
Save.

(* Petit test de division par une constante *)

Theorem div_by_c:
  (x,y:Z) ~(Zplus (Zmult x |2|) (Zplus (Zmult y |2|) |1|))=|0|.

Intros; Omega.
Save.

(* Cet exemple ne passe pas avec ARITH de Boulton (Bledsoe-Shostak) *)

Theorem fail_arith:
  (m,n:Z) ~((Zle (Zplus |1| (Zmult |2| m)) (Zmult |2| n)) /\
            (Zle (Zmult |2| n) (Zplus |1| (Zmult |2| m)))).

Intros; Omega.
Save.

(* Ces exemples sont extraits de preuves Unity. On essaie d'avoir le 
 * minimum de traduction. Ces exemples montre la necessite de gerer 
 * efficacement ~ _ = _ *)

Parameter variable:Set.
Parameter y, z: variable.

Theorem test5:
  (m,n,N : nat)
  (s : variable->nat)
  (Depart : ((lt (s y) (s z))/\(gt (s z) N)/\(s y)=m/\(s z)=n)
            /\~((s y)=m/\(lt (s z) n)))
  (Hltb : (lt (s y) (mult (2) (s z))))

  ((lt (s y) N)/\(gt N N)/\(s y)=m/\N=n\/(s y)=m/\(lt N n)).

Intros; Omega.
Save.

Theorem test6:
  (m,n,N : nat)
  (s : variable->nat)
  (Depart : ((lt (s y) (s z))/\(gt (s z) N)/\(s y)=m/\(s z)=n)
           /\~((s y)=m/\(lt (s z) n)))
  (Hltb : (le (mult (2) (s z)) (s y)))
 
  ((lt (s y) (mult (2) (s z)))
   /\(gt (mult (2) (s z)) N)/\(s y)=m/\(mult (2) (s z))=n
   \/(s y)=m/\(lt (mult (2) (s z)) n)).

Intros; Omega.
Save.

Theorem test7:
  (m,n,N : nat)
  (s : variable->nat)
  (Depart : ((lt (s y) (s z))/\(gt (s z) N)/\(s y)=m/\(s z)=n)
           /\~((s y)=m/\(lt (s z) n)))
  (Hltb : (lt (s y) (s z)))

  ((lt (s y) (s z))/\(gt (s z) N)/\(s y)=m/\(s z)=n
   \/(s y)=m/\(lt (s z) n)).

Intros; Omega.
Save.

Theorem test8:
  (m,n,N : nat)
  (s : variable->nat)
  (Depart : ((lt (s y) (s z))/\(gt (s z) N)/\(s y)=m/\(s z)=n)
           /\~((s y)=m/\(lt (s z) n)))
  (Hltb : (le (s z) (s y)))

  ((lt (minus (s y) (s z)) (s z))
   /\(gt (s z) N)/\(minus (s y) (s z))=m/\(s z)=n
   \/(minus (s y) (s z))=m/\(lt (s z) n)).

Intros; Omega.
Save.







