(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.1                                 *)
(*                               Oct 1st 1996                               *)
(*                                                                          *)
(****************************************************************************)
(*                            DatatypesSyntax.v                             *)
(****************************************************************************)

(* Parsing of things in Datatypes.v *)

Grammar command command1 :=
  pair_expl [ "<" lcommand($l1) "," lcommand($c2) ">" "(" command($c3) ","
    command($c4) ")" ] -> [<<(pair $l1 $c2 $c3 $c4)>>]
| fst_expl [ "<" lcommand($l1) "," lcommand($c2) ">" "Fst" "("
    lcommand($l) ")" ] -> [<<(fst $l1 $c2 $l)>>]
| snd_expl [ "<" lcommand($l1) "," lcommand($c2) ">" "Snd" "("
    lcommand($l) ")" ] -> [<<(snd $l1 $c2 $l)>>]

with command0 :=
  pair [ "(" lcommand($lc1) "," lcommand($lc2) ")" ] ->
         [<<(pair ? ? $lc1 $lc2)>>]

with command3 :=
  prod [ command2($c1) "*" command3($c2) ] -> [<<(prod $c1 $c2)>>]

with lassoc_command4 :=
 LEFTA squash_sum
  [ lassoc_command4($c1) "+" lassoc_command4($c2) ] ->
      case [$c2] of
        <<(squash $T2)>> ->
            case [$c1] of
              <<(squash $T1)>> -> [<<(sumbool $T1 $T2)>>]
            | $_ -> [<<(sumor $c1 $T2)>>]
            esac
      | $_ -> [<<(sum $c1 $c2)>>]
      esac.
