(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.1                                 *)
(*                               Oct 1st 1996                               *)
(*                                                                          *)
(****************************************************************************)
(*                            Logic_TypeSyntax.v                            *)
(****************************************************************************)

(* Parsing of things in Logic_type.v *)

Grammar command command1 :=
  eqT_expl [ "<" lcommand($l1) ">" command0($c1) "==" command0($c2) ] ->
          [<<(eqT $l1 $c1 $c2)>>]
| eqT_impl [ command0($c) "==" command0($c2) ] -> [<<(eqT ? $c $c2)>>]
| idT_expl [ "<" lcommand($l1) ">" command0($c1) "===" command0($c2) ] ->
          [<<(identityT $l1 $c1 $c2)>>]
| idT_impl [ command0($c) "===" command0($c2) ] -> [<<(identityT ? $c $c2)>>]

with command10 :=
  allTexplicit [ "ALLT" ident($v) ":" command($t) "|" command($c1) ]
                          -> [<<(allT $t [$v:$t]$c1)>>]
| allTimplicit [ "ALLT" ident($v) "|" command($c1) ] 
                          -> [<<(allT ? [$v]$c1)>>]
| exTexplicit [ "EXT" ident($v) ":" command($t) "|" command($c1) ]
                          -> [<<(exT $t [$v:$t]$c1)>>]
| exTimplicit [ "EXT" ident($v) "|" command($c1) ] 
                          -> [<<(exT ? [$v]$c1)>>]
| exT2explicit [ "EXT" ident($v) ":" command($t) "|" command($c1) "&"
           command($c2) ] -> [<<(exT2 $t [$v:$t]$c1 [$v:$t]$c2)>>]
| exT2implicit [ "EXT" ident($v) "|" command($c1) "&" 
           command($c2) ] -> [<<(exT2 ? [$v]$c1 [$v]$c2)>>].

(* $Id: Logic_TypeSyntax.v,v 1.8 1997/11/28 14:00:53 barras Exp $ *)
