(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.1                                 *)
(*                               Oct 1st 1996                               *)
(*                                                                          *)
(****************************************************************************)
(*                              SpecifSyntax.v                              *)
(****************************************************************************)

(* Parsing of things in Specif.v *)

Require Export DatatypesSyntax.

Grammar command command1 :=
  sig [ "{" lcommand($lc) ":" lcommand($c1) "|" lcommand($c2) "}" ]
       -> case [$lc] of ($VAR $id) -> [<<(sig $c1 [$id:$c1]$c2)>>] esac

| sig2 [ "{" lcommand($lc) ":" lcommand($c1)
           "|" lcommand($c2) "&" lcommand($c3) "}" ]
       -> case [$lc] of
           ($VAR $id) -> [<<(sig2 $c1 [$id:$c1]$c2 [$id:$c1]$c3)>>]
          esac

| sigS [ "{" lcommand($lc) ":" lcommand($c1) "&" lcommand($c2) "}" ]
       -> case [$lc] of ($VAR $id) -> [<<(sigS $c1 [$id:$c1]$c2)>>] esac

| sigS2 [ "{" lcommand($lc) ":" lcommand($c1)
             "&" lcommand($c2) "&" lcommand($c3) "}" ]
       -> case [$lc] of
            ($VAR $id) -> [<<(sigS2 $c1 [$id:$c1]$c2 [$id:$c1]$c3)>>]
          esac

| squash [ "{" lcommand($lc) "}" ] -> [(APPLIST squash $lc)].

(* $Id: SpecifSyntax.v,v 1.7 1997/09/15 19:06:17 werner Exp $ *)
