(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA                        ENS-CNRS                *)
(*              Rocquencourt                        Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.1                                 *)
(*                              Sept 1st 1995                               *)
(*                                                                          *)
(****************************************************************************)
(*                           A_total_ordering.v                             *)
(****************************************************************************)

(* G. Huet 1-9-95 *)

Require Generic.

(**********************************************)
(* We postulate a decidable ordering inf on A *)
(**********************************************)

Parameter   inf : A -> A -> Prop.
Definition sup  [x,y:A]~(inf x y).

Axiom inf_sup : (x,y:A){(inf x y)}+{(sup x y)}.
Axiom inf_sup_sym : (x,y:A)(sup x y)->(inf y x).
Axiom inf_tran : (x,y,z:A)(inf x y)->(inf y z)->(inf x z).
Axiom inf_refl : (x:A)(inf x x).

Hint inf_refl inf_sup inf_sup_sym.

Immediate inf_sup_sym.

Lemma inf_sup_tran : (x,y,z:A)(sup y x)->(inf y z)->(inf x z).
Proof.
Intros x y z H H0 ; Apply inf_tran with y ; Auto.
Qed.

(* $Id: A_decidable_ordering.v,v 1.2 1996/09/26 14:03:39 jcfillia Exp $ *)
